DECLARE FUNCTION GetSerNum$ ()
DECLARE FUNCTION GetChn% ()
DECLARE SUB PutKey (a$)                 'A$ = key to unlock channels
DECLARE SUB GetChanData (a%)            'a% = channel enabled bit data
DECLARE SUB DICommand (comm$)           'comm$ = DI-194 command
DECLARE SUB SelectCommPort (port$)      'port$ = comm port number
DECLARE FUNCTION SetRate! (rate$)       'rate$ = sample rate betwwen 1 and 240


' Global and constant data
DIM SHARED ChanData(4) AS INTEGER
DIM SHARED DI(3) AS INTEGER
DIM SHARED NumChn AS INTEGER
DIM Rec AS INTEGER
DIM Cont AS INTEGER
DIM NumSamples AS DOUBLE
DIM MaxNumSamples AS DOUBLE

CONST TRUE = -1
CONST FALSE = 0


ON ERROR GOTO ErrorHandler

CALL SelectCommPort("2")        'Select comm port
Rec = 0                         'rec = 0 for no recording; 1 for recording
Cont = 1                        'Flag for loop
NumSamples = 0                  'Number of samples stored to a file
MaxNumSamples = 100000          'Max number of samples stored to a file

CLS
PRINT "         *******************************************************"
PRINT "         *                                                     *"
PRINT "         *    DATAQ QBASIC DEMO program for the DI-194         *"
PRINT "         *                                                     *"
PRINT "         *  The serial number for your DI-194 is ";
PRINT GetSerNum$; "    *"
PRINT "         *                                                     *"
PRINT "         *******************************************************"

CALL PutKey("A8448E5A")         'A key is needed for multi channel operation
                                'The key is available for $49.95
                                'Call DATAQ at 1-330-668-1444 ext 194
LOCATE 10, 1, 1

a% = GetChn%                    'a% = bit ored Channel enable. Bit = 1 enabled
                                'bit0 = chn1, bit1 = chn2, bit2 = chn3, bit3 = chn4

CALL DICommand("C" + CHR$(a%))  'Select channels

PRINT : INPUT "Enter a desired SAMPLE RATE between 1 and 240 "; SamRate$

PRINT "The actual SAMPLE RATE is : "; SetRate!(SamRate$)

PRINT : INPUT "Enter a file name to record your DATA to "; file$

OPEN file$ FOR OUTPUT AS #2

COLOR 0, 7
LOCATE 25, 1
PRINT "<Press Esc to Quit> ";

COLOR 2, 7
LOCATE 25, 25
PRINT "<Press 'R' to start Recording>";
COLOR 7, 0

CALL DICommand("D1")            'Set D3 to input mode

CALL DICommand("S1")            'Start acq


LOCATE , , 0                    'Turn the cursor off
Cont = 1                        'Continue = 1
DO WHILE Cont = 1
   a$ = INKEY$
   IF a$ <> "" THEN
        IF a$ = CHR$(27) THEN Cont = 0
        IF a$ = "r" OR a$ = "R" THEN
                Rec = (Rec + 1) AND 1
                IF Rec = 1 THEN
                        COLOR 4, 7
                        LOCATE 25, 25
                        PRINT "<Press 'R' to stop  Recording>";
                        COLOR 7, 0
                ELSE
                        COLOR 2, 7
                        LOCATE 25, 25
                        PRINT "<Press 'R' to start Recording>";
                        COLOR 7, 0
                END IF
        END IF
   END IF

   bit% = 1
   CALL GetChanData(a%)
   data$ = ""
   FOR i = 1 TO 4
        LOCATE 18, 1 + (i - 1) * 19
        IF (bit% AND a%) = bit% THEN
                a! = (ChanData(i) - 128) * .0781
                PRINT "Chn"; i; " = "; a!
                data$ = data$ + STR$(a!) + ","
        END IF
        bit% = bit% + bit%
   NEXT i
   IF Rec = 1 THEN
        IF NumSamples <> MaxNumSamples THEN
                PRINT #2, data$      'record data to file
                NumSamples = NumSamples + 1
                COLOR 0, 7
                LOCATE 25, 59
                PRINT "<Samples = "; NumSamples; ">";
                COLOR 7, 0
        END IF
   END IF
  
   FOR i = 1 TO 3
        LOCATE 20, 1 + (i - 1) * 19
        PRINT "Din"; i; " = "; DI(i)
   NEXT i
LOOP

CALL DICommand("S0")       'Stop acq

CLOSE #1
CLOSE #2

END

ErrorHandler:
PRINT "IO error"
   END

'       Send command to DI194 at #1
SUB DICommand (comm$)
   a$ = CHR$(0) + comm$            'Send null then ASCII command
   PRINT #1, a$;
   DO WHILE INPUT$(1, #1) <> LEFT$(comm$, 1)  'Wait for command response
   LOOP
   a$ = INPUT$(1, #1)           'Get command data
END SUB

SUB GetChanData (a%)

   BYTE% = ASC(INPUT$(1, #1))           'get sync bit
   DO WHILE ((BYTE% AND 1) = 1)
        BYTE% = ASC(INPUT$(1, #1))
   LOOP
  
   DI(1) = BYTE% AND 2                    'fill Digital input data
   DI(2) = BYTE% AND 4
   DI(3) = BYTE% AND 8
   bit% = 1
   FOR i = 1 TO 4                         'fill ChanData with 8 bit binary data
        IF (bit% AND a%) = bit% THEN
                ChanData%(i) = (BYTE% / 128) + (ASC(INPUT$(1, #1)) AND &HFE)
                IF i <> 4 THEN BYTE% = ASC(INPUT$(1, #1))
        END IF
        bit% = bit% + bit%
   NEXT i

END SUB

FUNCTION GetChn%
        PRINT "Enter the channels to enable such as 1234 or 13 for example"
        PRINT "Then press Enter after the channel numbers ? ";
       
        a% = 0: NumChn = 0
        c$ = INKEY$
        PRINT c$;
        DO WHILE c$ <> CHR$(13)
                IF c$ = "1" THEN a% = a% OR 1: NumChn = NumChn + 1
                IF c$ = "2" THEN a% = a% OR 2: NumChn = NumChn + 1
                IF c$ = "3" THEN a% = a% OR 4: NumChn = NumChn + 1
                IF c$ = "4" THEN a% = a% OR 8: NumChn = NumChn + 1
                c$ = INKEY$
                PRINT c$;
        LOOP
        IF a% = 0 THEN a% = 1: NumChn = 1       'error if no channels enabled
        GetChn% = a%
END FUNCTION

FUNCTION GetSerNum$
   CALL DICommand("N0")          'Select two channels
   GetSerNum$ = INPUT$(10, #1)   'Get command d
END FUNCTION

SUB PutKey (a$)
        FOR i = 1 TO 8
           CALL DICommand("E" + MID$(a$, i, 1)) 'Send Key
        NEXT i
END SUB

SUB SelectCommPort (port$)
   OPEN "COM" + port$ + ":4800,N,8,1,BIN,CD0,CS0,DS0,TB2048,RB2048" FOR RANDOM AS #1

'       Wait .5 seconds for DI-194 to initialize  '
  
   start! = TIMER
   WHILE (TIMER - start!) < .5
   WEND


'     Clear any spurious readings from buffer
   a$ = INPUT$(LOC(1), #1)

END SUB

FUNCTION SetRate! (rate$)
        rate! = VAL(rate$)
        IF rate! <= 0 THEN rate! = 1
        IF rate! > 240 THEN d = 240
        d! = (4800! / rate!) - 20! * NumChn
        IF d < 1 THEN d = 0
        i% = d!
        CALL DICommand("L" + CHR$(i% AND &HFF))
        CALL DICommand("M" + CHR$((i% / 256) AND &HFF))
        SetRate! = 4800! / (20! * NumChn + i%)
END FUNCTION

